%% Cepstrum vs LPC
clear; close all; clc;
load('vowels');x=vowel_a';
N=length(x);
f=linspace(0,fs,N); 

%Cepstrum
ceps=real(ifft(log(abs(fft(x)))));
L=20;
ceps_lifter=[ceps(N-L:N) ceps(1:L)];

figure(1), hold on
plot(f,20*log10(abs(fft(x(8e3:12e3),N))),'r');   
plot(f,20*log10(abs(fft(ceps_lifter,N))),'linewidth',2);  
xlim([0 4000])
xlabel('Frequency in Hertz')
ylabel('Magnitude (dB)')
legend('DFT','Cepstrum')
%%
%LPC
p=12;
[a,g] = lpc(x,p);
[H,f] = freqz(1,a,N,'whole',fs);

figure(2), hold on
plot(f,20*log10(abs(fft(x(8e3:12e3),N))),'r');   
plot(f,20*log10(abs(H)),'k','linewidth',2);  
xlim([0 4000])
xlabel('Frequency in Hertz')
ylabel('Magnitude (dB)')
legend('DFT','LPC')

%%
figure(3), hold on
plot(f,20*log10(abs(fft(x(8e3:12e3),N))),'r');   
plot(f,20*log10(abs(H)),'k','linewidth',2);  
plot(f,20*log10(abs(fft(ceps_lifter,N))),'b','linewidth',2);  
xlim([0 4000])
xlabel('Frequency in Hertz')
ylabel('Magnitude (dB)')
legend('DFT','LPC', 'Cepstrum')

%%
figure(4), hold on
N2=128;
f2=linspace(0,fs,N2); 
plot(f,20*log10(abs(fft(x(8e3:12e3),N))),'r');   
plot(f,20*log10(abs(H)),'k','linewidth',2);  
plot(f,20*log10(abs(fft(ceps_lifter,N))),'b','linewidth',2);
plot(f2,20*log10(abs(fft(x(8e3:12e3),N2))),'g','linewidth',2);
xlim([0 4000])
xlabel('Frequency in Hertz')
ylabel('Magnitude (dB)')
legend('DFT','LPC', 'Cepstrum','DFT short')
